#include <SoftwareSerial.h>     //dodaje niezbędną bubliotekę

//dodatkowy software'owy port szeregowy dla debugowania
SoftwareSerial softSerial(2,3);

String softBuffer = "";         //bufor danych z USB
String blueBuffer = "";         //bufor danych z Bluetooth
int blueComplete = 0;           //znacznik odebranych danych z Bluetooth
int blueStatus = 0;             //status polączenia Bluetooth, aktywe to 1
int statusDelay;                //odlicza czas do zerwania połączenia
int ledPin = 13;               //dioda led na płycie Arduino

int motor_Rgo =   9;
int motor_Rback =   10;
int motor_Lgo =   5;
int motor_Lback =   6;

int vectX;
int vectY;

//--------------------------------------------------
void setup() {
  //uruchamia sprzetowy port szeregowy
  Serial.begin(19200);
  //uruchamia dodatkowy port szeregowy
  softSerial.begin(19200);

  digitalWrite(motor_Rgo, LOW);
  digitalWrite(motor_Rback, LOW);
  digitalWrite(motor_Lgo, LOW);
  digitalWrite(motor_Lback, LOW);
  pinMode(motor_Rgo, OUTPUT);
  pinMode(motor_Rback, OUTPUT);
  pinMode(motor_Lgo, OUTPUT);
  pinMode(motor_Lback, OUTPUT);

  //konfiguruje sterowanie diodą led
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, LOW);
}

//--------------------------------------------------
void loop() {
  int i;
  char data;
  char minus;
  
  //odczytujemy dane z portu szeregowego
  blueReceive();

  //------------------------------------------------
  //Moduł BTM222 rozpoczyna każdy komunikat znakiem końca linii
  //więc czekamy az będa 2 znaki końca
  if (blueComplete >= 2) 
  {              //jesli odebrano z Bluetooth
      if (blueBuffer.charAt(1) == 'x') 
      {
        blueStatus = 1;
        statusDelay = 0;
        i = 2;
        vectX = 0;
        
        data = blueBuffer.charAt(i);
        if (data == '-') {
          minus = -1;
          i++;
        } else minus = 1;  
        
        data = blueBuffer.charAt(i);

        if ((data >= '0') && (data <= '9'))
        {
          vectX += (data - '0');
          i++;
          data = blueBuffer.charAt(i);
          if ((data >= '0') && (data <= '9'))
          {
            vectX *= 10;
            vectX += (data - '0');
            i++;
          } 
        }
        vectX *= minus;

        vectY = 0;
        data = blueBuffer.charAt(i);
        if (data == ',') i++;
        
        data = blueBuffer.charAt(i);        
        if (data == '-') {
          minus = -1;
          i++;
        } else minus = 1;  
        
        data = blueBuffer.charAt(i);

        if ((data >= '0') && (data <= '9'))
        {
          vectY += (data - '0');
          i++;
          data = blueBuffer.charAt(i);
          if ((data >= '0') && (data <= '9'))
          {
            vectY *= 10;
            vectY += (data - '0');
            i++;
          } 
        }
        vectY *= minus;
      }

    blueBuffer = "";                    //czyści bufor
    blueComplete = 0;                   //zeruje znacznk odebranych danych
    vect2pwm(vectY, vectX);
  }

  //------------------------------------------------
  if (statusDelay <= 100) statusDelay++;
  else blueStatus = 0;
  if (statusDelay == 100) {
    vect2pwm(0, 0);
    blueBuffer = "";
    blueComplete = 0; 
  }
  
  //------------------------------------------------
  if (blueStatus == 1)
    digitalWrite(ledPin, HIGH);         //aktywne połączenie LED świeci
  else
    digitalWrite(ledPin, LOW);          //brak połączenia LED nie świeci
    
  delay(10);
}

//--------------------------------------------------
//odbieranie danych z Bluetooth
void blueReceive()
{
  while (Serial.available()) {    //jeśli coś odebrane
    char inData = (char)Serial.read();  //odbierz dane
    if ((blueComplete == 0) && (inData == '\n')) {
       blueBuffer = "";                    //czyści bufor
    }      
    blueBuffer += inData;             //i umieść w buforze
    if (inData == '\n') {             //jesli koniec linii
       blueComplete++;               //ustaw znacznik
    }
  }
}

//--------------------------------------------------
//Wysyła dane do Bluetooth
void vect2pwm (int vect1, int vect2) {
  int pwm_Rgo;
  int pwm_Rback;
  int pwm_Lgo;
  int pwm_Lback;


  //vect range = -99...0...99

  if (vect1 >= 0) {
    if (vect1 > 0)  {
      pwm_Rback = (vect1 * 2) + 57;   //uzupełnienie z 198 do 255
      pwm_Lback = (vect1 * 2) + 57;   //uzupełnienie z 198 do 255
    } else {
      pwm_Rback = 0;
      pwm_Lback = 0;    
    }
    pwm_Rgo = 0;
    pwm_Lgo = 0;
  } else {
    pwm_Rgo = (vect1 * -2) + 57;   //uzupełnienie z 198 do 255
    pwm_Lgo = (vect1 * -2) + 57;   //uzupełnienie z 198 do 255
    pwm_Rback = 0;
    pwm_Lback = 0;    
  }

  if (vect2 >= 0) {
    vect2 *= 2;
    if (pwm_Rgo > 0) pwm_Rgo -= vect2;
    if (pwm_Lback > 0) pwm_Lback -= vect2;
  } else {
    vect2 *= -2;
    if (pwm_Lgo > 0) pwm_Lgo -= vect2;
    if (pwm_Rback > 0) pwm_Rback -= vect2;
  }

  if (pwm_Rgo < 0) pwm_Rgo = 0;
  if (pwm_Lgo < 0) pwm_Lgo = 0;
  if (pwm_Rback < 0) pwm_Rback = 0;
  if (pwm_Lback < 0) pwm_Lback = 0;

  analogWrite(motor_Rback, pwm_Rback);
  analogWrite(motor_Lback, pwm_Lback);
  analogWrite(motor_Rgo, pwm_Rgo);
  analogWrite(motor_Lgo, pwm_Lgo);

  //Serial.println(pwm_Rgo);  
  //Serial.println(pwm_Lgo);  
  //Serial.println(pwm_Rback);  
  //Serial.println(pwm_Lback);  
}

